
Imports System.Runtime.InteropServices

Partial Class AviStream_API

    <StructLayout(LayoutKind.Sequential)> _
    Private Structure RGBQUAD
        Public rgbBlue As Byte
        Public rgbGreen As Byte
        Public rgbRed As Byte
        Public rgbReserved As Byte
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Private Structure BITMAPINFO
        Dim bmiHeader As BITMAPINFOHEADER
        Dim bmiColors As RGBQUAD
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Private Structure BITMAPINFOHEADER '40 bytes
        Dim biSize As Int32
        Dim biWidth As Int32
        Dim biHeight As Int32
        Dim biPlanes As Int16
        Dim biBitCount As Int16
        Dim biCompression As Int32
        Dim biSizeImage As Int32
        Dim biXPelsPerMeter As Int32
        Dim biYPelsPerMeter As Int32
        Dim biClrUsed As Int32
        Dim biClrImportant As Int32
    End Structure

    Private Structure AVI_FILE_INFO
        Dim dwMaxBytesPerSec As Integer
        Dim dwFlags As Integer
        Dim dwCaps As Integer
        Dim dwStreams As Integer
        Dim dwSuggestedBufferSize As Integer
        Dim dwWidth As Integer
        Dim dwHeight As Integer
        Dim dwScale As Integer
        Dim dwRate As Integer
        Dim dwLength As Integer
        Dim dwEditCount As Integer
        <VBFixedString(64), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValArray, SizeConst:=64)> _
        Public szFileType() As Char
    End Structure

    Private Structure AVI_STREAM_INFO
        Public fccType As Int32
        Public fccHandler As Int32
        Public dwFlags As Int32
        Public dwCaps As Int32
        Public wPriority As Int16
        Public wLanguage As Int16
        Public dwScale As Int32
        Public dwRate As Int32
        Public dwStart As Int32
        Public dwLength As Int32
        Public dwInitialFrames As Int32
        Public dwSuggestedBufferSize As Int32
        Public dwQuality As Int32
        Public dwSampleSize As Int32
        Public rcFrame As Rectangle
        Public dwEditCount As Int32
        Public dwFormatChangeCount As Int32
        <Runtime.InteropServices.MarshalAs(Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=64)> _
        Public szName As String
    End Structure

    'Private Const STRETCH_HALFTONE As Int32 = 4

    'Private Declare Function SetStretchBltMode Lib "gdi32" (ByVal hdc As Int32, ByVal nStretchMode As Int32) As Int32

    'Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Int32, _
    '                                                 ByVal x As Int32, _
    '                                                 ByVal y As Int32, _
    '                                                 ByVal nWidth As Int32, _
    '                                                 ByVal nHeight As Int32, _
    '                                                 ByVal hSrcDC As Int32, _
    '                                                 ByVal xSrc As Int32, _
    '                                                 ByVal ySrc As Int32, _
    '                                                 ByVal nSrcWidth As Int32, _
    '                                                 ByVal nSrcHeight As Int32, _
    '                                                 ByVal dwRop As Int32) As Int32


    '=========== SetDIBitsToDevice ======================================================================

    'Private Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hdc As Int32, _
    '                                                ByVal x As Int32, _
    '                                                ByVal y As Int32, _
    '                                                ByVal dx As Int32, _
    '                                                ByVal dy As Int32, _
    '                                                ByVal SrcX As Int32, _
    '                                                ByVal SrcY As Int32, _
    '                                                ByVal Scan As Int32, _
    '                                                ByVal NumScans As Int32, _
    '                                                ByVal Bits As Int32, _
    '                                                ByVal BitsInfo As BITMAPINFO, _
    '                                                ByVal wUsage As Int32) As Int32


    '=========== StretchDIBits ==========================================================================

    'Private Declare Function StretchDIBits Lib "gdi32" Alias "StretchDIBits" (ByVal hdc As Int32, _
    '                                                                         ByVal x As Int32, _
    '                                                                         ByVal y As Int32, _
    '                                                                         ByVal dx As Int32, _
    '                                                                         ByVal dy As Int32, _
    '                                                                         ByVal SrcX As Int32, _
    '                                                                         ByVal SrcY As Int32, _
    '                                                                         ByVal wSrcWidth As Int32, _
    '                                                                         ByVal wSrcHeight As Int32, _
    '                                                                         ByVal lpBits As Int32, _
    '                                                                         <Runtime.InteropServices.MarshalAs(Runtime.InteropServices.UnmanagedType.Struct)> _
    '                                                                         ByRef lpBitsInfo As BITMAPINFO, _
    '                                                                         ByVal wUsage As Int32, _
    '                                                                         ByVal dwRop As Int32) As Int32


    '=========== DRAW DIB ==========================================================================

    'Private Declare Sub DrawDibSetPalette Lib "msvfw32" (ByVal hdrawdib As Int32, _
    '                                                     ByVal hpalette As Int32)

    'Private Declare Sub DrawDibRealize Lib "msvfw32" (ByVal hdrawdib As Int32, _
    '                                                  ByVal hdc As Int32, _
    '                                                  ByVal fBackground As Boolean)

    'Private Declare Function DrawDibOpen Lib "msvfw32" () As Integer

    'Private Declare Function DrawDibClose Lib "msvfw32" (ByVal hdrawdib As Int32) As Int32

    'Private Declare Function DrawDibDraw Lib "msvfw32" (ByVal hdrawdib As Int32, _
    '                                                    ByVal hdc As Int32, _
    '                                                    ByVal xDst As Int32, _
    '                                                    ByVal yDst As Int32, _
    '                                                    ByVal dxDst As Int32, _
    '                                                    ByVal dyDst As Int32, _
    '                                                    ByRef lpbi As BITMAPINFOHEADER, _
    '                                                    ByVal lpBits As Int32, _
    '                                                    ByVal xSrc As Int32, _
    '                                                    ByVal ySrc As Int32, _
    '                                                    ByVal dxSrc As Int32, _
    '                                                    ByVal dySrc As Int32, _
    '                                                    ByVal wFlags As Int32) As Int32


    '=========== AVI FILE ==========================================================================

    Private Declare Function AVIFileOpen Lib "avifil32" (ByRef ppfile As Int32, _
                                                         ByVal szFile As [String], _
                                                         ByVal uMode As Int32, _
                                                         ByVal pclsidHandler As Int32) As Int32

    Private Declare Function AVIFileRelease Lib "avifil32" (ByVal pfile As Int32) As Int32

    Private Declare Function AVIFileInfo Lib "avifil32" Alias "AVIFileInfoA" (ByVal pfile As Int32, _
                                                                              ByRef pAfi As AVI_FILE_INFO, _
                                                                              ByVal afiSize As Int32) As Int32

    Private Declare Sub AVIFileInit Lib "avifil32" ()
    Private Declare Sub AVIFileExit Lib "avifil32" ()


    '========== OPEN CLOSE ========================================================================

    Public Declare Function AVIStreamOpenFromFile Lib "avifil32" _
                                                  Alias "AVIStreamOpenFromFileA" (ByRef ppavi As Int32, _
                                                                                  ByVal szFile As String, _
                                                                                  ByVal fccType As Int32, _
                                                                                  ByVal lParam As Int32, _
                                                                                  ByVal mode As Int32, _
                                                                                  ByVal pclsidHandler As Int32) As Int32

    Private Declare Function AVIStreamRelease Lib "avifil32" (ByVal ppavi As Int32) As Int32


    Private Declare Function AVIStreamBeginStreaming Lib "avifil32" (ByVal ppavi As Int32, _
                                                                     ByVal StartFrame As Int32, _
                                                                     ByVal EndFrame As Int32, _
                                                                     ByVal speed As Int32) As Int32
    ' Speed 1000 = normal


    Private Declare Function AVIStreamEndStreaming Lib "avifil32" (ByVal ppavi As Int32) As Int32



    '========== READ ============================================================================

    ' Returns a pointer to the frame data if successful or NULL otherwise.
    ' The frame data is returned as a packed DIB.
    Public Declare Function AVIStreamGetFrameOpen Lib "avifil32" (ByVal ppavi As Int32, _
                                                                  ByVal bihWanted As Short) As Int32

    Private Declare Function AVIStreamGetFrameClose Lib "avifil32" (ByVal pGetFrame As Int32) As Int32


    Private Declare Function AVIStreamGetFrame Lib "avifil32" (ByVal pGetFrame As Int32, _
                                                               ByVal position As Int32) As Int32

    Private Declare Function AVIStreamRead Lib "avifil32" (ByVal ppavi As Int32, _
                                                           ByVal startSample As Int32, _
                                                           ByVal nSamples As Int32, _
                                                           ByVal pBuffer As Int32, _
                                                           ByVal lenBuffer As Int32, _
                                                           ByVal ppBytes As Int32, _
                                                           ByVal ppSamples As Int32) As Int32


    '====== FIND INFORMATIONS ======================================================================

    Private Declare Function AVIStreamFindSample Lib "avifil32" (ByVal ppavi As Int32, _
                                                                 ByVal lpos As Int32, _
                                                                 ByVal lFlags As Int32) As Int32

    Private Declare Function AVIStreamLength Lib "avifil32" (ByVal ppavi As Int32) As Int32

    Private Declare Function AVIStreamSampleToTime Lib "avifil32" (ByVal ppavi As Int32, _
                                                                   ByVal sample As Int32) As Int32

    Private Declare Function AVIStreamInfo Lib "avifil32" Alias "AVIStreamInfoA" (ByVal ppavi As Int32, _
                                                                                  ByRef pAsi As AVI_STREAM_INFO, _
                                                                                  ByVal asiSize As Int32) As Int32

    Private Declare Function AVIStreamReadFormat Lib "avifil32" (ByVal ppavi As Int32, _
                                                                 ByVal lpos As Int32, _
                                                                 ByVal lpFormat As Int32, _
                                                                 ByVal lpcbformat As Int32) As Int32

    'Public Declare Function AVIStreamReadFormat Lib "avifil32" (ByVal ppavi As Int32, _
    '                                                            ByVal lpos As Int32, _
    '                                                            ByRef lpFormat As Win32.PCMWAVEFORMAT, _
    '                                                            ByRef lpcbformat As Integer) As Int32

    '====== CONSTANTS =============================================================================

    Private Const OF_SHARE_DENY_WRITE As Int32 = 32
    Private Const AVIGETFRAMEF_BESTDISPLAYFMT As Int32 = 1
    Private Const DIB_RGB_COLORS As Int32 = 0
    Private Const SRCCOPY As Int32 = 13369376

    Private Declare Function mmioStringToFOURCC Lib "winmm.dll" _
                                               Alias "mmioStringToFOURCCA" (ByVal sz As String, _
                                                                            ByVal uFlags As Int32) As Int32

    Private Shared Function FourCC(ByVal text As String) As Int32
        FourCC = mmioStringToFOURCC(text, 0)
    End Function

    Private Shared Function DecodeError(ByVal code As Int32) As String
        code = code And 255
        DecodeError = "Unknown Error" & Str(code)
        Select Case code
            Case 101 : DecodeError = "AVIERR_UNSUPPORTED"
            Case 102 : DecodeError = "AVIERR_BADFORMAT"
            Case 103 : DecodeError = "AVIERR_MEMORY"
            Case 104 : DecodeError = "AVIERR_INTERNAL"
            Case 105 : DecodeError = "AVIERR_BADFLAGS"
            Case 106 : DecodeError = "AVIERR_BADPARAM"
            Case 107 : DecodeError = "AVIERR_BADSIZE"
            Case 108 : DecodeError = "AVIERR_BADHANDLE"
            Case 109 : DecodeError = "AVIERR_FILEREAD"
            Case 110 : DecodeError = "AVIERR_FILEWRITE"
            Case 111 : DecodeError = "AVIERR_FILEOPEN"
            Case 112 : DecodeError = "AVIERR_COMPRESSOR"
            Case 113 : DecodeError = "AVIERR_NOCOMPRESSOR"
            Case 114 : DecodeError = "AVIERR_READONLY"
            Case 115 : DecodeError = "AVIERR_NODATA"
            Case 116 : DecodeError = "AVIERR_BUFFERTOOSMALL"
            Case 117 : DecodeError = "AVIERR_CANTCOMPRESS"
            Case 198 : DecodeError = "AVIERR_USERABORT"
            Case 199 : DecodeError = "AVIERR_ERROR"
        End Select
    End Function


    '========== ALPHA BLEND ============================================================================

    'Private Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hRefDC As Int32) As Int32

    'Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Int32, ByVal hObject As Int32) As Int32

    'Private Declare Function DeleteDC Lib "gdi32.dll" (ByVal hdc As Int32) As Boolean

    'Private Structure BLENDFUNCTION
    '    Dim blendOp As Byte
    '    Dim BlendFlags As Byte
    '    Dim SourceConstantAlpha As Byte
    '    Dim AlphaFormat As Byte
    'End Structure

    '' BlendOp:
    'Private Const AC_SRC_OVER As Int32 = 0
    '' AlphaFormat:
    'Private Const AC_SRC_ALPHA As Int32 = 1

    'Private Declare Function alphaBlend Lib "msimg32.dll" Alias "AlphaBlend" (ByVal hdcDest As Int32, _
    '                                                                          ByVal nXOriginDest As Int32, _
    '                                                                          ByVal nYOriginDest As Int32, _
    '                                                                          ByVal nWidthDest As Int32, _
    '                                                                          ByVal nHeightDest As Int32, _
    '                                                                          ByVal hdcSrc As Int32, _
    '                                                                          ByVal nXOriginSrc As Int32, _
    '                                                                          ByVal nYOriginSrc As Int32, _
    '                                                                          ByVal nWidthSrc As Int32, _
    '                                                                          ByVal nHeightSrc As Int32, _
    '                                                                          ByVal lBlendFunction As Int32) As Int32

    'Private Declare Function alphaBlend Lib "msimg32.dll" Alias "AlphaBlend" (ByVal hdcDest As Int32, _
    '                                                                      ByVal nXOriginDest As Int32, _
    '                                                                      ByVal nYOriginDest As Int32, _
    '                                                                      ByVal nWidthDest As Int32, _
    '                                                                      ByVal nHeightDest As Int32, _
    '                                                                      ByVal hdcSrc As Int32, _
    '                                                                      ByVal nXOriginSrc As Int32, _
    '                                                                      ByVal nYOriginSrc As Int32, _
    '                                                                      ByVal nWidthSrc As Int32, _
    '                                                                      ByVal nHeightSrc As Int32, _
    '                                                                      ByVal lBlendFunction As BLENDFUNCTION) As Int32

    'Private Declare Function TransparentBlt Lib "msimg32.dll" (ByVal hdc As Int32, _
    '                                                           ByVal x As Int32, _
    '                                                           ByVal y As Int32, _
    '                                                           ByVal nWidth As Int32, _
    '                                                           ByVal nHeight As Int32, _
    '                                                           ByVal hSrcDC As Int32, _
    '                                                           ByVal xSrc As Int32, _
    '                                                           ByVal ySrc As Int32, _
    '                                                           ByVal nSrcWidth As Int32, _
    '                                                           ByVal nSrcHeight As Int32, _
    '                                                           ByVal crTransparent As Int32) As Boolean




    Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByVal Destination As Int32, _
                                                                             ByVal Source As Int32, _
                                                                             ByVal Length As Int32)

End Class