﻿Module Module_Utils

    ' =======================================================================================
    '  TrayWnd
    ' =======================================================================================
    Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Int32
    Private Declare Function ShowWindow Lib "user32" (ByVal hwnd As Int32, ByVal nCmdShow As Int32) As Int32
    Private Const SW_HIDE As Int32 = 0
    Private Const SW_SHOW As Int32 = 5

    Friend Sub HideTrayWnd()
        Dim lngHandle As Int32
        lngHandle = FindWindow("Shell_TrayWnd", "")
        ShowWindow(lngHandle, SW_HIDE)
    End Sub

    Friend Sub ShowTrayWnd()
        Dim lngHandle As Int32
        lngHandle = FindWindow("Shell_TrayWnd", "")
        ShowWindow(lngHandle, SW_SHOW)
    End Sub


    ' ==============================================================================================================
    '   COMBO FUNCTIONS
    ' ==============================================================================================================

    Friend Sub Combo_Init(ByVal combo As ComboBox, ByVal str As String)
        Dim old As Boolean = EventsAreEnabled
        EventsAreEnabled = False
        If str = Nothing Then str = ""
        With combo
            .Items.Clear()
            .Items.Add(str)
            .SelectedIndex = 0
        End With
        EventsAreEnabled = old
    End Sub

    Friend Sub Combo_SetIndex_FromString(ByVal combo As ComboBox, ByVal str As String)
        Dim old As Boolean = EventsAreEnabled
        EventsAreEnabled = False
        If str = Nothing Then str = ""
        With combo
            For i As Int32 = 0 To .Items.Count - 1
                If .Items(i).ToString.ToLower = str.ToLower Then
                    .SelectedIndex = i
                    Exit For
                End If
            Next
        End With
        EventsAreEnabled = old
    End Sub

    Friend Function Combo_GetValue(ByVal combo As ComboBox) As String
        If combo.SelectedIndex < 0 Then Return ""
        Return combo.Items(combo.SelectedIndex).ToString()
    End Function

    Friend Sub Combo_SetIndex(ByVal combo As ComboBox, ByVal index As Int32)
        If combo.Items.Count < 1 Then Exit Sub
        If index < 0 Then index = 0
        If index > combo.Items.Count - 1 Then index = combo.Items.Count - 1
        combo.SelectedIndex = index
    End Sub




    ' ============================================================================================
    '  LOCK DESKTOP UPDATE - very powerful and never flickers
    '  LOCK UPDATE         - use this on forms, otherwise it can flash desktop icons
    '  UNLOCK UPDATE       - use this to terminate the locked section
    ' ============================================================================================
    Private Declare Function LockWindowUpdate Lib "User32" (ByVal hWnd As IntPtr) As Int32
    Private Declare Function GetDesktopWindow Lib "user32" Alias "GetDesktopWindow" () As IntPtr
    Friend Sub LockDesktopUpdate()
        LockWindowUpdate(GetDesktopWindow)
    End Sub
    Friend Sub LockUpdate(ByVal ctrl As Control)
        LockWindowUpdate(ctrl.Handle)
    End Sub
    Friend Sub UnlockUpdate()
        LockWindowUpdate(Nothing)
    End Sub



End Module
